----------------------------------------------------------------------------------
-- ********* Fleatiny-FPGA CH376T USB Host to FT230x serial interface module ***********
-- Slightly more complex example of custom logic module creation, using more than one input 
-- and output signal into the module.
--
-- Please Note: This source code is provided as-is and is only intended to illustrate
-- how to implement a simple VHDL project using FleaFPGA.
--
-- Creation Date: 15th December 2013
-- Author: Valentin Angelovski
--
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;

entity CH376T_to_FT230x is

  port(
		slave_rx_i: in  STD_LOGIC;
		slave_tx_o: out  STD_LOGIC;
		host_tx_o: out  STD_LOGIC;
		host_rx_i: in  STD_LOGIC;
		reset_host: out  STD_LOGIC;
		button2: in  STD_LOGIC;
		CH376_TX_LED: buffer  STD_LOGIC;
		CH376_RX_LED: buffer  STD_LOGIC);

END CH376T_to_FT230x;  
  
  
ARCHITECTURE behavior OF CH376T_to_FT230x IS

	SIGNAL  serial_to_usbhost  : STD_LOGIC;
	SIGNAL  serial_from_usbhost  : STD_LOGIC;
   

BEGIN

	reset_host <= NOT button2; 	
	serial_to_usbhost <= slave_rx_i;
	host_tx_o <= serial_to_usbhost;
	CH376_RX_LED <= serial_to_usbhost;
	serial_from_usbhost <= host_rx_i;
	slave_tx_o <= serial_from_usbhost;
	CH376_TX_LED <= serial_from_usbhost; 
 
 
end architecture;