----------------------------------------------------------------------------------
-- ********* Fleatiny-FPGA Blinky LED example module ***********
-- Very simple example of how to create a custom logic module using HDL
-- Following VHDL code describes an up-counter with a count range of 25 million
-- Counter value is incremented by the external system clock (which is 50MHz on the fleaFPGA)
-- LED1 on FleaFPGA will be toggled, every time the counter value reaches 25 million 
-- and reset back to zero
--
-- Please Note: This source code is provided as-is and is only intended to illustrate
-- how to implement a simple VHDL project using FleaFPGA.
--
-- Creation Date: 15th December 2013
-- Author: Valentin Angelovski
--
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;

entity blinky is

  port(
		clk: in  STD_LOGIC;
		blink_LED: BUFFER  STD_LOGIC);

END blinky;  
  
  
ARCHITECTURE behavior OF blinky IS

BEGIN
   PROCESS(clk)
      VARIABLE count :   INTEGER RANGE 0 TO 25_000_000;
 
   BEGIN
      IF(clk'EVENT AND clk = '1') THEN
         IF(count < 25_000_000) THEN
            count := count + 1;
         ELSE
		    count := 0;
            blink_LED <= NOT blink_LED;
         END IF;
      END IF;
   END PROCESS; 
 
 
end architecture;